## task 2.3.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
set(CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required

include (CheckFunctionExists)
include (CheckStructHasMember)

set (HAVE_CMAKE true)

project (task)
set (PROJECT_VERSION "2.3.0")

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set (LINUX true)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set (DARWIN true)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "kFreeBSD")
  set (KFREEBSD true)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  set (FREEBSD true)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
  set (OPENBSD true)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
  set (NETBSD true)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
  set (SOLARIS true)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "GNU")
  set (GNUHURD true)
else (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set (UNKNOWN true)
endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

if (FREEBSD)
SET (TASK_MAN1DIR man/man1 CACHE STRING "Installation directory for man pages, section 1")
SET (TASK_MAN5DIR man/man5 CACHE STRING "Installation directory for man pages, section 5")
else (FREEBSD)
SET (TASK_MAN1DIR share/man/man1 CACHE STRING "Installation directory for man pages, section 1")
SET (TASK_MAN5DIR share/man/man5 CACHE STRING "Installation directory for man pages, section 5")
endif (FREEBSD)
SET (TASK_DOCDIR  share/doc/task CACHE STRING "Installation directory for doc files")
SET (TASK_RCDIR "${TASK_DOCDIR}/rc" CACHE STRING "Installation directory for configuration files")
SET (TASK_BINDIR  bin            CACHE STRING "Installation directory for the binary")

message ("-- Looking for SHA1 references")
if (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)
  set (HAVE_COMMIT true)
  execute_process (COMMAND git log -1 --pretty=format:%h
                   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                   OUTPUT_VARIABLE COMMIT)
  configure_file ( ${CMAKE_SOURCE_DIR}/commit.h.in
                   ${CMAKE_SOURCE_DIR}/commit.h)
  message ("-- Found SHA1 reference: ${COMMIT}")
endif (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)

set (PACKAGE "${PROJECT_NAME}")
set (VERSION "${PROJECT_VERSION}")
set (PACKAGE_BUGREPORT "support@taskwarrior.org")
set (PACKAGE_NAME "${PACKAGE}")
set (PACKAGE_TARNAME "${PACKAGE}")
set (PACKAGE_VERSION "${VERSION}")
set (PACKAGE_STRING "${PACKAGE} ${VERSION}")

message ("-- Looking for GnuTLS")
find_package (GnuTLS)
if (GNUTLS_FOUND)
  set (HAVE_LIBGNUTLS true)
  set (TASK_INCLUDE_DIRS ${TASK_INCLUDE_DIRS} ${GNUTLS_INCLUDE_DIR})
  set (TASK_LIBRARIES    ${TASK_LIBRARIES}    ${GNUTLS_LIBRARIES})
endif (GNUTLS_FOUND)

#message ("-- Looking for pthread")
#find_path (PTHREAD_INCLUDE_DIR pthread.h)
#find_library (PTHREAD_LIBRARY NAMES pthread)
#if (PTHREAD_INCLUDE_DIR AND PTHREAD_LIBRARY)
#  message ("-- Found pthread: ${PTHREAD_LIBRARY}")
#  set (HAVE_LIBPTHREAD true)
#  set (TASK_INCLUDE_DIRS ${TASK_INCLUDE_DIRS} ${PTHREAD_INCLUDE_DIR})
#  set (TASK_LIBRARIES    ${TASK_LIBRARIES}    ${PTHREAD_LIBRARIES})
#endif (PTHREAD_INCLUDE_DIR AND PTHREAD_LIBRARY)

# include the readline library finder module
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules")

# find readline
message ("-- Looking for GNU Readline")
find_package (Readline)
if (READLINE_FOUND)
  set (HAVE_READLINE true)
  set (TASK_INCLUDE_DIRS ${TASK_INCLUDE_DIRS} ${READLINE_INCLUDE_DIR})
  set (TASK_LIBRARIES    ${TASK_LIBRARIES}    ${READLINE_LIBRARIES})
endif (READLINE_FOUND)

check_function_exists (timegm  HAVE_TIMEGM)
check_function_exists (get_current_dir_name HAVE_GET_CURRENT_DIR_NAME)
check_function_exists (wordexp HAVE_WORDEXP)

check_struct_has_member ("struct tm" tm_gmtoff time.h HAVE_TM_GMTOFF)
check_struct_has_member ("struct stat" st_birthtime "sys/types.h;sys/stat.h" HAVE_ST_BIRTHTIME)

message ("-- Looking for libuuid")
if (DARWIN OR FREEBSD)
  # Apple and FreeBSD include the uuid functions in their libc, rather than libuuid
  check_function_exists (uuid_unparse_lower HAVE_UUID_UNPARSE_LOWER)
else (DARWIN OR FREEBSD)
  find_path    (UUID_INCLUDE_DIR   uuid/uuid.h)
  find_library (UUID_LIBRARY NAMES uuid)
  if (UUID_INCLUDE_DIR AND UUID_LIBRARY)
    set (TASK_INCLUDE_DIRS ${TASK_INCLUDE_DIRS} ${UUID_INCLUDE_DIR})
    set (TASK_LIBRARIES    ${TASK_LIBRARIES}    ${UUID_LIBRARY})
    # Look for uuid_unparse_lower
    set (CMAKE_REQUIRED_INCLUDES  ${CMAKE_REQUIRED_INCLUDES}  ${UUID_INCLUDE_DIR})
    set (CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${UUID_LIBRARY})
    check_function_exists (uuid_unparse_lower HAVE_UUID_UNPARSE_LOWER)
  else (UUID_INCLUDE_DIR AND UUID_LIBRARY)
    message (FATAL_ERROR "-- libuuid not found.")
  endif (UUID_INCLUDE_DIR AND UUID_LIBRARY)
endif (DARWIN OR FREEBSD)

if (HAVE_UUID_UNPARSE_LOWER)
  message ("-- Found libuuid")
else (HAVE_UUID_UNPARSE_LOWER)
  message ("-- Found libuuid, using internal uuid_unparse_lower")
endif (HAVE_UUID_UNPARSE_LOWER)

# Set the package language.
if (LANGUAGE)
  set (PACKAGE_LANGUAGE ${LANGUAGE})
else (LANGUAGE)
  set (PACKAGE_LANGUAGE 1)
endif (LANGUAGE)

set (LANGUAGE_EN_US 1)
set (LANGUAGE_ES_ES 2)
set (LANGUAGE_DE_DE 3)
set (LANGUAGE_FR_FR 4)
set (LANGUAGE_IT_IT 5)

message ("-- Configuring cmake.h")
configure_file (
  ${CMAKE_SOURCE_DIR}/cmake.h.in
  ${CMAKE_SOURCE_DIR}/cmake.h)

add_subdirectory (src)
add_subdirectory (src/commands)
add_subdirectory (src/columns)
add_subdirectory (src/shell)
add_subdirectory (doc)
add_subdirectory (i18n)
add_subdirectory (scripts)
if (EXISTS ${CMAKE_SOURCE_DIR}/test)
  add_subdirectory (test EXCLUDE_FROM_ALL)
endif (EXISTS ${CMAKE_SOURCE_DIR}/test)
if (EXISTS performance)
  add_subdirectory (performance EXCLUDE_FROM_ALL)
endif (EXISTS performance)

set (doc_FILES NEWS ChangeLog README INSTALL AUTHORS COPYING)
foreach (doc_FILE ${doc_FILES})
  install (FILES ${doc_FILE}  DESTINATION ${TASK_DOCDIR})
endforeach (doc_FILE)

# ---

set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_NAME}-${PACKAGE_VERSION})
set (CPACK_SOURCE_IGNORE_FILES  "CMakeCache" "CMakeFiles" "CPackConfig" "CPackSourceConfig"
                                "_CPack_Packages" "cmake_install" "install_manifest" "Makefile$"
                                "test" "package-config" "misc/*" "src/task$" "src/libtask.a"
                                "src/columns/libcolumns.a" "src/commands/libcommands.a"
                                "src/shell/tasksh$" "src/shell/libtasksh.a" "auto.h$"
                                "/\\.gitignore" "/\\.git/" "swp$")
include (CPack)

=== doc/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
message ("-- Configuring man pages")
set (man_FILES task-color.5 task-faq.5 task-sync.5 task-tutorial.5 taskrc.5 task.1 tasksh.1)
foreach (man_FILE ${man_FILES})
  configure_file (
    man/${man_FILE}.in
    man/${man_FILE})
endforeach (man_FILE)

install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man/   DESTINATION ${TASK_MAN1DIR}
                                                      FILES_MATCHING PATTERN "*.1")
install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man/   DESTINATION ${TASK_MAN5DIR}
                                                      FILES_MATCHING PATTERN "*.5")
install (DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/rc     DESTINATION ${TASK_DOCDIR})

install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/ref/task-ref.pdf DESTINATION ${TASK_DOCDIR})

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/src/commands
                     ${CMAKE_SOURCE_DIR}/src/columns
                     ${TASK_INCLUDE_DIRS})

set (task_SRCS A3.cpp A3.h
               Arg.cpp Arg.h
               Color.cpp Color.h
               Config.cpp Config.h
               Context.cpp Context.h
               DOM.cpp DOM.h
               Date.cpp Date.h
               Directory.cpp Directory.h
               Duration.cpp Duration.h
               E9.cpp E9.h
               File.cpp File.h
               Hooks.cpp Hooks.h
               JSON.cpp JSON.h
               Msg.cpp Msg.h
               Nibbler.cpp Nibbler.h
               Path.cpp Path.h
               RX.cpp RX.h
               TDB2.cpp TDB2.h
               Task.cpp Task.h
               Taskmod.cpp Taskmod.h
               Timer.cpp Timer.h
               TLSClient.cpp TLSClient.h
               Transport.cpp Transport.h
               TransportCurl.cpp TransportCurl.h
               TransportRSYNC.cpp TransportRSYNC.h
               TransportSSH.cpp TransportSSH.h
               TransportShell.cpp TransportShell.h
               Uri.cpp Uri.h
               ViewTask.cpp ViewTask.h
               ViewText.cpp ViewText.h
               dependency.cpp
               feedback.cpp
               i18n.h
               interactive.cpp
               legacy.cpp
               recur.cpp
               rules.cpp
               sort.cpp
               text.cpp text.h
               utf8.cpp utf8.h
               util.cpp util.h
               wcwidth6.cpp)

add_library (task STATIC ${task_SRCS})
add_executable (task_executable main.cpp)

# Yes, 'task' is included twice, other linking fails on assorted OSes.
target_link_libraries (task_executable task commands columns task ${TASK_LIBRARIES})

set_property (TARGET task_executable PROPERTY OUTPUT_NAME "task")

install (TARGETS task_executable DESTINATION ${TASK_BINDIR})

#SET(CMAKE_BUILD_TYPE gcov)
#SET(CMAKE_CXX_FLAGS_GCOV "--coverage")
#SET(CMAKE_C_FLAGS_GCOV "--coverage")
#SET(CMAKE_EXE_LINKER_FLAGS_GCOV "--coverage")

=== test/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/src/commands
                     ${CMAKE_SOURCE_DIR}/src/columns
                     ${CMAKE_SOURCE_DIR}/test
                     ${TASK_INCLUDE_DIRS})

set (test_SRCS autocomplete.t color.t config.t date.t directory.t dom.t
               duration.t file.t i18n.t json.t list.t msg.t nibbler.t path.t
               rx.t t.t t2.t t3.t taskmod.t tdb2.t text.t uri.t utf8.t util.t
               view.t width.t json_test)

message ("-- Configuring run_all")
if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

set (TESTBLOB "./*.t")
if (CYGWIN)
  set (TESTBLOB "./*.t ./*.t.exe")
endif (CYGWIN)

else (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

set (TESTBLOB "${CMAKE_SOURCE_DIR}/test/*.t ${CMAKE_BINARY_DIR}/test/*.t")
if (CYGWIN)
  set (TESTBLOB "${CMAKE_SOURCE_DIR}/test/*.t ${CMAKE_BINARY_DIR}/test/*.t.exe")
endif (CYGWIN)

endif (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

configure_file (run_all.in run_all)

add_custom_target (test ./run_all --verbose
                        DEPENDS ${test_SRCS} task_executable
                        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/test)

add_custom_target (build_tests DEPENDS ${test_SRCS}
                               WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/test)

foreach (src_FILE ${test_SRCS})
  add_executable (${src_FILE} "${src_FILE}.cpp" test.cpp)
  target_link_libraries (${src_FILE} task commands task columns ${TASK_LIBRARIES})
endforeach (src_FILE)

#SET(CMAKE_BUILD_TYPE gcov)
#SET(CMAKE_CXX_FLAGS_GCOV "--coverage")
#SET(CMAKE_C_FLAGS_GCOV "--coverage")
#SET(CMAKE_EXE_LINKER_FLAGS_GCOV "--coverage")

=== src/commands/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/src/commands
                     ${CMAKE_SOURCE_DIR}/src/columns
                     ${TASK_INCLUDE_DIRS})

set (commands_SRCS Command.cpp        Command.h
                   CmdAdd.cpp         CmdAdd.h
                   CmdAliases.cpp     CmdAliases.h
                   CmdAnnotate.cpp    CmdAnnotate.h
                   CmdAppend.cpp      CmdAppend.h
                   CmdBurndown.cpp    CmdBurndown.h
                   CmdCalendar.cpp    CmdCalendar.h
                   CmdCommands.cpp    CmdCommands.h
                   CmdColor.cpp       CmdColor.h
                   CmdColumns.cpp     CmdColumns.h
                   CmdConfig.cpp      CmdConfig.h
                   CmdCount.cpp       CmdCount.h
                   CmdCustom.cpp      CmdCustom.h
                   CmdDelete.cpp      CmdDelete.h
                   CmdDenotate.cpp    CmdDenotate.h
                   CmdDiagnostics.cpp CmdDiagnostics.h
                   CmdDone.cpp        CmdDone.h
                   CmdDuplicate.cpp   CmdDuplicate.h
                   CmdEdit.cpp        CmdEdit.h
                   CmdExec.cpp        CmdExec.h
                   CmdExport.cpp      CmdExport.h
                   CmdGet.cpp         CmdGet.h
                   CmdHelp.cpp        CmdHelp.h
                   CmdHistory.cpp     CmdHistory.h
                   CmdIDs.cpp         CmdIDs.h
                   CmdImport.cpp      CmdImport.h
                   CmdInfo.cpp        CmdInfo.h
                   CmdLog.cpp         CmdLog.h
                   CmdLogo.cpp        CmdLogo.h
                   CmdMerge.cpp       CmdMerge.h
                   CmdModify.cpp      CmdModify.h
                   CmdPrepend.cpp     CmdPrepend.h
                   CmdProjects.cpp    CmdProjects.h
                   CmdPull.cpp        CmdPull.h
                   CmdPush.cpp        CmdPush.h
                   CmdReports.cpp     CmdReports.h
                   CmdShow.cpp        CmdShow.h
                   CmdStart.cpp       CmdStart.h
                   CmdStats.cpp       CmdStats.h
                   CmdStop.cpp        CmdStop.h
                   CmdSummary.cpp     CmdSummary.h
                   CmdSync.cpp        CmdSync.h
                   CmdTags.cpp        CmdTags.h
                   CmdTimesheet.cpp   CmdTimesheet.h
                   CmdUDAs.cpp        CmdUDAs.h
                   CmdUndo.cpp        CmdUndo.h
                   CmdUrgency.cpp     CmdUrgency.h
                   CmdVersion.cpp     CmdVersion.h)

add_library (commands STATIC ${commands_SRCS})

#SET(CMAKE_BUILD_TYPE gcov)
#SET(CMAKE_CXX_FLAGS_GCOV "--coverage")
#SET(CMAKE_C_FLAGS_GCOV "--coverage")
#SET(CMAKE_EXE_LINKER_FLAGS_GCOV "--coverage")

=== src/shell/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/src/commands
                     ${CMAKE_SOURCE_DIR}/src/columns
                     ${CMAKE_SOURCE_DIR}/src/shell
                     ${TASK_INCLUDE_DIRS})

set (tasksh_SRCS Readline.cpp Readline.h)

add_library (tasksh STATIC ${tasksh_SRCS})
add_executable (tasksh_executable main.cpp)

# Yes, 'task' is included twice, otherwise linking fails on CentOS.
target_link_libraries (tasksh_executable task commands columns tasksh task ${TASK_LIBRARIES})

set_property (TARGET tasksh_executable PROPERTY OUTPUT_NAME "tasksh")

install (TARGETS tasksh_executable DESTINATION ${TASK_BINDIR})

=== debian/changelog ===
task (2.3.0+dfsg-3) unstable; urgency=low

  * Improve the get-orig-source script:
    + Use the POSIX 1003.1-1988 (ustar) format for tarballs.
  * Update the watch file.
  * Add patch (default-editor.diff) to change the default editor from “vi” to
    “editor”, as per Policy §11.4.
  * Add patch (fix-task-sync-man-url.diff) to fix task server setup
    documentation URL (closes: #749180).
    Thanks to Axel Beckert for the bug report.
  * Use “dpkg-parsechangelog -SVersion” for extracting version number in
    debian/rules.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 31 May 2014 23:22:30 +0200

task (2.3.0+dfsg-2) unstable; urgency=low

  * Update git URL in the get-orig-source script.
  * Use dh-buildinfo:
    + Update debian/rules.
    + Add the package to Build-Depends.
  * Add DEP-8 tests that run adequate(1) against the packages.
  * Add patch (tests-count-eom.diff) to make the count.t test failures on the
    last day of the month non-fatal (closes: #743238). Thanks to James
    Dietrich for the bug report and the analysis of the problem.
  * Remove a long obsolete comment from debian/rules.
  * Drop tests-unset-env-vars.diff, as the problem of test suite stomping on
    user's data has been fixed upstream.
    Set TASKDATA and TASKRC to specially-crafted values (both in debian/rules
    and in the DEP-8 test), so that task trips over it if the problem
    reappears in the future 
  * Mark tests-fail.diff as forwarded upstream.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 02 Apr 2014 11:33:52 +0200

task (2.3.0+dfsg-1) unstable; urgency=low

  * Upload to unstable.
  * Repackage .orig.tar to remove documentation that cannot be edited with
    free tools (closes: #737478).
  * Add patch (no-task-ref.diff) not try to install task-ref.pdf, as it's now
    missing.
  * Drop code to remove pre-built static libraries from debian/rules, as they
    are not included in the repacked .orig.tar.
  * Switch to xz compression, both for .orig.tar and .debian.tar.
  * Update the watch file.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 13 Feb 2014 23:33:28 +0100

task (2.3.0-1) experimental; urgency=low

  * New upstream release.
  * Fix debian/watch to correctly handle non-beta versions.
  * Drop patches that were applied upstream:
    + customizable-rcdir.diff;
    + no-path-max.diff;
    + tests-fix-pri-sort.diff;
    + tests-fix-bug.annual.diff;
    + system-kfreebsd.diff;
    + system-hurd.diff;
    + typos.diff.
  * Refresh remaining patches.
  * Add patch (fix-groff-warnings.diff) to fix some groff warnings.
  * Force gzip for .debian.tar compression.

 -- Jakub Wilk <jwilk@debian.org>  Sun, 19 Jan 2014 23:19:34 +0100

task (2.3.0~beta2-2) experimental; urgency=low

  * Add patches (tests-fix-pri-sort.diff, tests-fix-bug.annual.diff) to fix a
    few test failures.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 08 Jan 2014 12:23:45 +0100

task (2.3.0~beta2-1) experimental; urgency=low

  * New upstream beta release.
  * Update the watch file and the get-orig-source script to accept beta
    versions.
  * Drop patches that were applied upstream:
    + tests-out-of-tree.diff;
    + tests-temporary-directory.diff;
    + directory-no-path-max.diff;
    * directory-handle-dt-unknown.diff.
  * Refresh remaining patches.
  * Fix support for GNU/Hurd and GNU/kFreeBSD:
    + Update system-kfreebsd.diff; partially applied upstream.
    + Update system-hurd.diff; partially applied upstream.
    + Add patch (no-path-max.diff) to use get_current_dir_name() instead of
      relying on PATH_MAX, as the latter is not defined on GNU/Hurd.
  * Add code to remove pre-built static libraries to debian/rules; the static
    libraries are back in .orig.tar…
  * Adapt the test suite to Debian needs:
    + Update tests-for-released-version.diff to allow running tests against a
      beta version of taskwarrior.
    + Add patch (tests-time-independent.diff) to disable checking if copyright
      information covers the current year.
  * Build-depend on libreadline-dev (needed by the new tasksh command).
  * Link with --as-needed, to avoid direct dependencies on ncurses.
  * Update DEP-8 tests for tasksh.
  * Update Depends in the DEP-8 control file, to takie into account the binary
    package rename.
  * Drop tests-set-build-type.diff. Instead, add a patch
    (enable-warnings.diff) to enable warnings globally and to stop hardcoding
    build type. Set build type in debian/rules via cmake configuration
    variable.
  * Add patch (typos.diff) to fix a few spelling mistakes.
  * Disable GnuTLS support for the time being.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 07 Jan 2014 22:35:48 +0100

task (2.2.0-4) experimental; urgency=low

  * Fix a typo in the copyright file.
  * Update years in the copyright file.
  * Bump standards version to 3.9.5 (no changes needed).
  * Replace patch to hardcode Debian-specific paths (debian-paths.diff) with a
    cleaner patch (customizable-rcdir.diff) that makes TASK_RCDIR customizable
    at configure time. Update deban/rules to set TASK_DOCDIR and TASK_RCDIR at
    configure time.
  * Rename the binary package: task → taskwarrior (closes: #719317).
    Thanks to Ben Armstrong for the bug report.
    + Rename the main package as “taskwarrior” in debian/control; add
      Conflicts/Replaces against the old “task” package.
    + Add transitional package to debian/control.
    + Move Pre-Depends to the transitional package.
    + Rename debhelper configuration files.
    + Update debian/rules and README.Debian accordingly.
    + Make /usr/share/task a symlink to /usr/share/taskwarrior, for backwards
      compatibility.
    + Add postinst script to deal with transitioning /usr/share/task from
      directory to symlink.
    + Add lintian override for conflicts-with-version. Conflicts makes
      transitioning /usr/share/task from directory to symlink slightly easier.
  * Keep the i18n directory in /usr/share/doc.
  * Drop code to remove pre-built static libraries from debian/rules; the


=== debian/control ===
Source: task
Section: utils
Priority: optional
Maintainer: Jakub Wilk <jwilk@debian.org>
Build-Depends:
 debhelper (>= 8.1), dh-buildinfo,
 dpkg-dev (>= 1.15.7),
 cmake,
 uuid-dev,
 libjson-perl,
 libreadline-dev,
Standards-Version: 3.9.5
Homepage: http://taskwarrior.org
XS-Testsuite: autopkgtest

Package: taskwarrior
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: task (<< 2.2.0-4~)
Replaces: task (<< 2.2.0-4~)
Description: feature-rich console based todo list manager
 Taskwarrior is a sophisticated command line todo list and task
 manager with a lot of features:
 .
  * colorful tabbed output
  * feature rich search function
  * tags
  * statistics
  * Getting Things Done compatible
  * interactive editing of items in text editor

Package: task
Section: oldlibs
Priority: extra
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, taskwarrior (= ${binary:Version})
Description: feature-rich console based todo list manager - transitional package
 Taskwarrior is a sophisticated command line todo list and task
 manager with a lot of features:
 .
 This is a transitional dummy package. It can be safely removed.

=== debian/rules ===
#!/usr/bin/make -f

cflags = $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
cxxflags = $(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
ldflags = $(shell dpkg-buildflags --get LDFLAGS)

cmake_options = \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_BUILD_TYPE=debug \
	-DCMAKE_C_FLAGS_DEBUG="$(cflags)" \
	-DCMAKE_CXX_FLAGS_DEBUG="$(cxxflags)" \
	-DCMAKE_EXE_LINKER_FLAGS_DEBUG="$(ldflags) -Wl,--as-needed" \
	-DTASK_DOCDIR=share/doc/taskwarrior \
	-DTASK_RCDIR=share/taskwarrior \
	-DCMAKE_DISABLE_FIND_PACKAGE_GnuTLS=TRUE \

parallel = -j$(or $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS))),1)

.PHONY: clean
clean: debian/control
	dh_clean
	rm -rf obj/
	rm -f cmake.h

.PHONY: build build-arch build-indep
build build-arch: obj/stamp

obj/stamp: debian/control
	mkdir -p $(dir $@)
	cd obj && cmake .. $(cmake_options)
	$(MAKE) -C obj/ $(parallel)
ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
	$(MAKE) -C obj/test/ $(parallel)
	mkdir -p obj/home/ obj/mock/
	echo 'this is not a valid taskrc' > obj/home/taskrc
	ln -sf /bin/false obj/mock/scp
	HOME="$(CURDIR)/obj/home/" \
	PATH="$(CURDIR)/obj/mock/:$$PATH" \
	TASKDATA="$(CURDIR)/obj/home/taskdata" \
	TASKRC="$(CURDIR)/obj/home/taskrc" \
	$(MAKE) -C obj/test/ test
	! ls -d obj/home/taskdata 2>/dev/null
endif
	touch $(@)

.PHONY: binary binary-arch binary-indep

binary: binary-arch
binary-arch: obj/stamp
	dh_testroot
	dh_prep
	$(MAKE) -C obj/ install DESTDIR=../debian/taskwarrior/
	mkdir -p debian/taskwarrior/usr/share/taskwarrior/
	set -e; cd debian/taskwarrior/usr/share/doc/taskwarrior; \
		rm rc/refresh; mv rc/* ../../taskwarrior; rmdir rc; \
		mv scripts/add-ons examples; \
		rm -rf scripts; \
		rm INSTALL COPYING ChangeLog;
	dh_install
	cd debian/taskwarrior/etc/bash_completion.d && mv task.sh task
	dh_installdocs
	dh_buildinfo
	dh_installchangelogs -p taskwarrior ChangeLog
	dh_installchangelogs -N taskwarrior -X ChangeLog
	dh_installexamples
	dh_installman
	dh_lintian
	dh_link
	dh_compress -Xexamples
	dh_fixperms
	dh_strip
	dh_shlibdeps
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

debdir = $(dir $(firstword $(MAKEFILE_LIST)))
version = $(shell dpkg-parsechangelog -SVersion)

.PHONY: get-orig-source
get-orig-source:
	sh $(debdir)/get-orig-source.sh $(version)

# vim:ts=4 sw=4 noet

=== debian/watch ===
version=3
opts="uversionmangle=s/[.]beta/~beta/,dversionmangle=s/[+]dfsg//" \
http://taskwarrior.org/download/ \
.*/task-([\d.]+(?:[.]beta\d+)?)\.tar\.gz

## task 2.4.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,8 @@
 cmake_minimum_required (VERSION 2.8)
 set(CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required
+if(POLICY CMP0037)
+  cmake_policy(SET CMP0037 OLD)
+endif()
 
 include (CheckFunctionExists)
 include (CheckStructHasMember)
@@ -7,12 +10,40 @@
 set (HAVE_CMAKE true)
 
 project (task)
-set (PROJECT_VERSION "2.3.0")
+set (PROJECT_VERSION "2.4.3")
+
+OPTION(USE_GNUTLS "Build gnutls support." ON)
+
+message ("CMAKE_SYSTEM_NAME ${CMAKE_SYSTEM_NAME}")
+
+include (CheckCXXCompilerFlag)
+
+# NOTE: If we are to actually use C++11 features, we should either require
+#       a compiler that supports the -std=c++11 flag or check for the
+#       features used.
+#       Relying on -std=c++0x or even -std=gnu++0x is highly volatile.
+
+CHECK_CXX_COMPILER_FLAG("-std=c++11" _HAS_CXX11)
+CHECK_CXX_COMPILER_FLAG("-std=c++0x" _HAS_CXX0X)
+CHECK_CXX_COMPILER_FLAG("-std=gnu++0x" _HAS_GNU0X)
+
+if (_HAS_CXX11)
+  set (_CXX11_FLAGS "-std=c++11")
+elseif (_HAS_CXX0X)
+  message (WARNING "Enabling -std=c++0x draft compile flag. Your compiler does not support the standard '-std=c++11' option.  Consider upgrading.")
+  set (_CXX11_FLAGS "-std=c++0x")
+elseif (_HAS_GNU0X)
+  message (WARNING "Enabling -std=gnu++0x draft compile flag. Your compiler does not support the standard '-std=c++11' option. Consider upgrading.")
+  set (_CXX11_FLAGS "-std=gnu++0x")
+else (_HAS_CXX11)
+ message (FATAL_ERROR "C++11 support missing. Try upgrading your C++ compiler. If you have a good reason for using an outdated compiler, please let us know at support@taskwarrior.org.")
+endif (_HAS_CXX11)
 
 if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
   set (LINUX true)
 elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
   set (DARWIN true)
+  set (_CXX11_FLAGS "${_CXX11_FLAGS} -stdlib=libc++")
 elseif (${CMAKE_SYSTEM_NAME} MATCHES "kFreeBSD")
   set (KFREEBSD true)
 elseif (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
@@ -25,9 +56,25 @@
   set (SOLARIS true)
 elseif (${CMAKE_SYSTEM_NAME} STREQUAL "GNU")
   set (GNUHURD true)
+elseif (${CMAKE_SYSTEM_NAME} STREQUAL "CYGWIN")
+  set (CYGWIN true)
+  # NOTE: Not setting -std=gnu++0x leads to compile errors even with
+  #       GCC 4.8.3, and debugging those leads to insanity. Adding this
+  #       workaround instead of fixing Cygwin.
+  set (_CXX11_FLAGS "-std=gnu++0x")
 else (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
   set (UNKNOWN true)
 endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+
+set (CMAKE_CXX_FLAGS "${_CXX11_FLAGS} ${CMAKE_CXX_FLAGS}")
+
+set (CMAKE_CXX_FLAGS "-Wall -Wsign-compare -Wreturn-type ${CMAKE_CXX_FLAGS}")
+
+if (NETBSD)
+   # Since readline, etc likely to be in /usr/pkg/lib, not standard library
+   # Otherwise will remove links during install
+   set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+endif (NETBSD)
 
 if (FREEBSD)
 SET (TASK_MAN1DIR man/man1 CACHE STRING "Installation directory for man pages, section 1")
@@ -59,35 +106,15 @@
 set (PACKAGE_VERSION "${VERSION}")
 set (PACKAGE_STRING "${PACKAGE} ${VERSION}")
 
-message ("-- Looking for GnuTLS")
-find_package (GnuTLS)
-if (GNUTLS_FOUND)
-  set (HAVE_LIBGNUTLS true)
-  set (TASK_INCLUDE_DIRS ${TASK_INCLUDE_DIRS} ${GNUTLS_INCLUDE_DIR})
-  set (TASK_LIBRARIES    ${TASK_LIBRARIES}    ${GNUTLS_LIBRARIES})
-endif (GNUTLS_FOUND)
-
-#message ("-- Looking for pthread")
-#find_path (PTHREAD_INCLUDE_DIR pthread.h)
-#find_library (PTHREAD_LIBRARY NAMES pthread)
-#if (PTHREAD_INCLUDE_DIR AND PTHREAD_LIBRARY)
-#  message ("-- Found pthread: ${PTHREAD_LIBRARY}")
-#  set (HAVE_LIBPTHREAD true)
-#  set (TASK_INCLUDE_DIRS ${TASK_INCLUDE_DIRS} ${PTHREAD_INCLUDE_DIR})
-#  set (TASK_LIBRARIES    ${TASK_LIBRARIES}    ${PTHREAD_LIBRARIES})
-#endif (PTHREAD_INCLUDE_DIR AND PTHREAD_LIBRARY)
-
-# include the readline library finder module
-set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules")
-
-# find readline
-message ("-- Looking for GNU Readline")
-find_package (Readline)
-if (READLINE_FOUND)
-  set (HAVE_READLINE true)
-  set (TASK_INCLUDE_DIRS ${TASK_INCLUDE_DIRS} ${READLINE_INCLUDE_DIR})
-  set (TASK_LIBRARIES    ${TASK_LIBRARIES}    ${READLINE_LIBRARIES})
-endif (READLINE_FOUND)
+if (USE_GNUTLS)
+   message ("-- Looking for GnuTLS")
+   find_package (GnuTLS)
+   if (GNUTLS_FOUND)
+     set (HAVE_LIBGNUTLS true)
+     set (TASK_INCLUDE_DIRS ${TASK_INCLUDE_DIRS} ${GNUTLS_INCLUDE_DIR})
+     set (TASK_LIBRARIES    ${TASK_LIBRARIES}    ${GNUTLS_LIBRARIES})
+   endif (GNUTLS_FOUND)
+endif (USE_GNUTLS)
 
 check_function_exists (timegm  HAVE_TIMEGM)
 check_function_exists (get_current_dir_name HAVE_GET_CURRENT_DIR_NAME)
@@ -128,11 +155,14 @@
   set (PACKAGE_LANGUAGE 1)
 endif (LANGUAGE)
 
-set (LANGUAGE_EN_US 1)
-set (LANGUAGE_ES_ES 2)
-set (LANGUAGE_DE_DE 3)
-set (LANGUAGE_FR_FR 4)
-set (LANGUAGE_IT_IT 5)
+set (LANGUAGE_ENG_USA 1)
+set (LANGUAGE_ESP_ESP 2)
+set (LANGUAGE_DEU_DEU 3)
+set (LANGUAGE_FRA_FRA 4)
+set (LANGUAGE_ITA_ITA 5)
+set (LANGUAGE_POR_PRT 6)
+set (LANGUAGE_EPO_RUS 7)
+set (LANGUAGE_POL_POL 8)
 
 message ("-- Configuring cmake.h")
 configure_file (
@@ -142,9 +172,7 @@
 add_subdirectory (src)
 add_subdirectory (src/commands)
 add_subdirectory (src/columns)
-add_subdirectory (src/shell)
 add_subdirectory (doc)
-add_subdirectory (i18n)
 add_subdirectory (scripts)
 if (EXISTS ${CMAKE_SOURCE_DIR}/test)
   add_subdirectory (test EXCLUDE_FROM_ALL)
@@ -153,7 +181,7 @@
   add_subdirectory (performance EXCLUDE_FROM_ALL)
 endif (EXISTS performance)
 
-set (doc_FILES NEWS ChangeLog README INSTALL AUTHORS COPYING)
+set (doc_FILES NEWS ChangeLog README.md INSTALL AUTHORS COPYING)
 foreach (doc_FILE ${doc_FILES})
   install (FILES ${doc_FILE}  DESTINATION ${TASK_DOCDIR})
 endforeach (doc_FILE)
@@ -164,8 +192,7 @@
 set (CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_NAME}-${PACKAGE_VERSION})
 set (CPACK_SOURCE_IGNORE_FILES  "CMakeCache" "CMakeFiles" "CPackConfig" "CPackSourceConfig"
                                 "_CPack_Packages" "cmake_install" "install_manifest" "Makefile$"
-                                "test" "package-config" "misc/*" "src/task$" "src/libtask.a"
-                                "src/columns/libcolumns.a" "src/commands/libcommands.a"
-                                "src/shell/tasksh$" "src/shell/libtasksh.a" "auto.h$"
+                                "test" "package-config" "misc/*" "src/task$" "src/calc$" "performance"
+                                "src/libtask.a" "src/columns/libcolumns.a" "src/commands/libcommands.a"
                                 "/\\.gitignore" "/\\.git/" "swp$")
 include (CPack)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -7,9 +7,15 @@
                      ${TASK_INCLUDE_DIRS})
 
 set (test_SRCS autocomplete.t color.t config.t date.t directory.t dom.t
-               duration.t file.t i18n.t json.t list.t msg.t nibbler.t path.t
-               rx.t t.t t2.t t3.t taskmod.t tdb2.t text.t uri.t utf8.t util.t
-               view.t width.t json_test)
+               file.t i18n.t json.t list.t msg.t nibbler.t path.t rx.t t.t t2.t
+               t3.t tdb2.t text.t utf8.t util.t view.t json_test lexer.t
+               iso8601d.t iso8601p.t duration.t variant_add.t
+               variant_and.t variant_cast.t variant_divide.t variant_equal.t
+               variant_exp.t variant_gt.t variant_gte.t variant_inequal.t
+               variant_lt.t variant_lte.t variant_match.t variant_math.t
+               variant_modulo.t variant_multiply.t variant_nomatch.t
+               variant_not.t variant_or.t variant_partial.t variant_subtract.t
+               variant_xor.t eval.t dates.t)
 
 message ("-- Configuring run_all")
 if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

=== src/commands/CMakeLists.txt ===
--- 
+++ 
@@ -10,12 +10,15 @@
                    CmdAliases.cpp     CmdAliases.h
                    CmdAnnotate.cpp    CmdAnnotate.h
                    CmdAppend.cpp      CmdAppend.h
+                   CmdAttributes.cpp  CmdAttributes.h
                    CmdBurndown.cpp    CmdBurndown.h
+                   CmdCalc.cpp        CmdCalc.h
                    CmdCalendar.cpp    CmdCalendar.h
                    CmdCommands.cpp    CmdCommands.h
                    CmdColor.cpp       CmdColor.h
                    CmdColumns.cpp     CmdColumns.h
                    CmdConfig.cpp      CmdConfig.h
+                   CmdContext.cpp     CmdContext.h
                    CmdCount.cpp       CmdCount.h
                    CmdCustom.cpp      CmdCustom.h
                    CmdDelete.cpp      CmdDelete.h
@@ -34,12 +37,9 @@
                    CmdInfo.cpp        CmdInfo.h
                    CmdLog.cpp         CmdLog.h
                    CmdLogo.cpp        CmdLogo.h
-                   CmdMerge.cpp       CmdMerge.h
                    CmdModify.cpp      CmdModify.h
                    CmdPrepend.cpp     CmdPrepend.h
                    CmdProjects.cpp    CmdProjects.h
-                   CmdPull.cpp        CmdPull.h
-                   CmdPush.cpp        CmdPush.h
                    CmdReports.cpp     CmdReports.h
                    CmdShow.cpp        CmdShow.h
                    CmdStart.cpp       CmdStart.h

=== debian/changelog ===
task (2.4.3+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sebastien Badia <seb@sebian.fr>  Wed, 29 Apr 2015 01:38:54 +0200

task (2.4.3+dfsg-1) experimental; urgency=medium

  [ Gordon Ball ]
  * New upstream release: 2.4.3
  * d/patches: Refresh for new release.

  [ Sebastien Badia ]
  * Fix version number in the maint script; Thanks Jakub! (Closes: #710321)

 -- Sebastien Badia <seb@sebian.fr>  Tue, 21 Apr 2015 17:59:33 +0200

task (2.4.1+dfsg-3) unstable; urgency=medium

  * Re-introduce Jakub fix for bash completion file (closes: #710321):
    + Rename /etc/bash_completion.d/task.sh back as /etc/bash_completion.d/task
    + Update debian/rules accordingly.
    + Add debian/maintscript to let dh_installdeb add maintainer script
      snippets to remove the old file, Debian version 2.4.1-1 was accidentally
      uploaded to unstable.
  * Fix install step (re-add rc files) (Closes: #779914).

 -- Sebastien Badia <seb@sebian.fr>  Sat, 07 Mar 2015 23:27:50 +0100

task (2.4.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sebastien Badia <seb@sebian.fr>  Fri, 06 Mar 2015 07:04:47 +0100

task (2.4.1+dfsg-1) unstable; urgency=medium

  [ Gordon Ball ]
  * d/patchs: Refresh according new upstream release
    * tests-fail.diff (fixed upstream, TW-1296)
    * tests-for-released-version.diff (fixed upstream)
    * tests-count-eom.diff (fixed upstream, TW-1295)
    * fix-task-sync-man-url.diff (fixed upstream)
  * Enable GnuTLS support (closes: #741625, LP: #1344560)
  * tasksh is now a separate project and no longer included in this package

  [ Sebastien Badia ]
  * New upstream release: 2.4.1 (LP: #1286939)
  * New maintainer (co-maint. with Gordon) (closes: #762130)
    * Many thanks to Gordon, Michel, Jack L. and Tobias Frost for the help!
  * d/NEWS: Add a note about the removal of tasksh.
  * d/copyright: Convert to dep5 format and fix lintian warnings.
  * d/rules: Convert to shorted dh format.
  * d/patchs: Sort, refresh, and remove unsed patchs.
    * Add missing DEP-3 headers on d/p/no-task-ref.patch
  * Enable full taskwarrior test suite (including python tests)
    (Thanks to Michel Voßkuhle)
  * Refresh debian/get-orig-source.sh (this script is used to import
    taskwarrior test-suite in the orig tarball)
  * d/control: Many changes
    * Update standard-version (no changes)
    * Upgrade debhelper compat format to 9
    * Remove dpkg-dev build dependency
    * Add python and git to build-deps (for the test suite)
    * Add vcs-* fields (this package is now managed with GIT)
  * Get package lintian clean
    * remove un-needed lintian override
    * fix quilt-patch-missing-description
    * fix manpage-has-errors-from-man
    * fix hyphen-used-as-minus-sign

 -- Sebastien Badia <seb@sebian.fr>  Sun, 01 Mar 2015 22:03:25 +0100

=== debian/control ===
Source: task
Section: utils
Priority: optional
Maintainer: Sebastien Badia <seb@sebian.fr>
Uploaders: Gordon Ball <gordon@chronitis.net>
Build-Depends: cmake,
               debhelper (>= 9),
               dh-buildinfo,
               git,
               libgnutls28-dev,
               libjson-perl,
               libreadline-dev,
               python,
               uuid-dev
Standards-Version: 3.9.6
Homepage: http://taskwarrior.org
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/task.git
Vcs-Git: git://anonscm.debian.org/collab-maint/task.git
XS-Testsuite: autopkgtest

Package: taskwarrior
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: task (<< 2.2.0-4~)
Replaces: task (<< 2.2.0-4~)
Description: feature-rich console based todo list manager
 Taskwarrior is a sophisticated command line todo list and task
 manager with a lot of features:
 .
  * colorful tabbed output
  * feature rich search function
  * tags
  * statistics
  * Getting Things Done compatible
  * interactive editing of items in text editor

Package: task
Section: oldlibs
Priority: extra
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: taskwarrior (= ${binary:Version}), ${misc:Depends}
Description: feature-rich console based todo list manager - transitional package
 Taskwarrior is a sophisticated command line todo list and task
 manager with a lot of features:
 .
 This is a transitional dummy package. It can be safely removed.

## task 2.4.4+dfsg

=== debian/changelog ===
task (2.4.4+dfsg-1) unstable; urgency=medium

  [ Gordon Ball ]
  * New upstream release: 2.4.4
  * Bash and fish completions now installed under /usr/share (see #776954)
  * Build should now be reproducible (`task diagnostics` will no longer
    show the build timestamp, which shouldn't make too much difference)

  [ Sebastien Badia ]
  * Upstream fix for typo in the 'NEWS' file (Closes: #789417)
  * Maintain a NEWS file with not only the latest version (Closes: #789420)

 -- Sebastien Badia <seb@sebian.fr>  Sun, 12 Jul 2015 11:45:10 +0200

## task 2.5.0%2Bdfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,5 @@
 cmake_minimum_required (VERSION 2.8)
 set(CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required
-if(POLICY CMP0037)
-  cmake_policy(SET CMP0037 OLD)
-endif()
 
 include (CheckFunctionExists)
 include (CheckStructHasMember)
@@ -10,9 +7,16 @@
 set (HAVE_CMAKE true)
 
 project (task)
-set (PROJECT_VERSION "2.4.3")
-
-OPTION(USE_GNUTLS "Build gnutls support." ON)
+set (PROJECT_VERSION "2.5.0")
+
+OPTION (ENABLE_SYNC "Enable 'task sync' support" ON)
+
+if (ENABLE_SYNC)
+  set (USE_GNUTLS ON CACHE BOOL "Build gnutls support." FORCE)
+else (ENABLE_SYNC)
+  set (USE_GNUTLS OFF CACHE BOOL "Build gnutls support." FORCE)
+  message (WARNING "ENABLE_SYNC=OFF. Not building sync support.")
+endif (ENABLE_SYNC)
 
 message ("CMAKE_SYSTEM_NAME ${CMAKE_SYSTEM_NAME}")
 
@@ -116,6 +120,10 @@
    endif (GNUTLS_FOUND)
 endif (USE_GNUTLS)
 
+if (ENABLE_SYNC AND NOT GNUTLS_FOUND)
+  message (FATAL_ERROR "Cannot find GnuTLS. Use -DENABLE_SYNC=OFF to build Taskwarrior without sync support. See INSTALL for more information.")
+endif (ENABLE_SYNC AND NOT GNUTLS_FOUND)
+
 check_function_exists (timegm  HAVE_TIMEGM)
 check_function_exists (get_current_dir_name HAVE_GET_CURRENT_DIR_NAME)
 check_function_exists (wordexp HAVE_WORDEXP)
@@ -163,6 +171,7 @@
 set (LANGUAGE_POR_PRT 6)
 set (LANGUAGE_EPO_RUS 7)
 set (LANGUAGE_POL_POL 8)
+set (LANGUAGE_JPN_JPN 9)
 
 message ("-- Configuring cmake.h")
 configure_file (
@@ -194,5 +203,5 @@
                                 "_CPack_Packages" "cmake_install" "install_manifest" "Makefile$"
                                 "test" "package-config" "misc/*" "src/task$" "src/calc$" "performance"
                                 "src/libtask.a" "src/columns/libcolumns.a" "src/commands/libcommands.a"
-                                "/\\.gitignore" "/\\.git/" "swp$")
+                                "/\\\\.gitignore" "/\\\\.git/" "swp$" "src/lex$")
 include (CPack)

## task 2.5.0+dfsg

=== doc/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
message ("-- Configuring man pages")
set (man_FILES task-color.5 task-sync.5 taskrc.5 task.1)
foreach (man_FILE ${man_FILES})
  configure_file (
    man/${man_FILE}.in
    man/${man_FILE})
endforeach (man_FILE)

install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man/   DESTINATION ${TASK_MAN1DIR}
                                                      FILES_MATCHING PATTERN "*.1")
install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man/   DESTINATION ${TASK_MAN5DIR}
                                                      FILES_MATCHING PATTERN "*.5")
install (DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/rc/    DESTINATION ${TASK_RCDIR})

install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/ref/task-ref.pdf DESTINATION ${TASK_DOCDIR})

=== scripts/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
install (DIRECTORY bash fish vim zsh hooks
         DESTINATION ${TASK_DOCDIR}/scripts)
install (DIRECTORY add-ons
         DESTINATION ${TASK_DOCDIR}/scripts
         FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
                          GROUP_READ             GROUP_EXECUTE
                          WORLD_READ             WORLD_EXECUTE)

=== test/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
if(POLICY CMP0037)
  cmake_policy(SET CMP0037 OLD)
endif()
include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/src/commands
                     ${CMAKE_SOURCE_DIR}/src/columns
                     ${CMAKE_SOURCE_DIR}/test
                     ${TASK_INCLUDE_DIRS})

set (test_SRCS autocomplete.t col.t color.t config.t fs.t i18n.t json.t list.t
               msg.t nibbler.t rx.t t.t t2.t t3.t tdb2.t text.t utf8.t util.t
               view.t json_test lexer.t iso8601d.t iso8601p.t eval.t dates.t
               variant_add.t variant_and.t variant_cast.t variant_divide.t
               variant_equal.t variant_exp.t variant_gt.t variant_gte.t
               variant_inequal.t variant_lt.t variant_lte.t variant_match.t
               variant_math.t variant_modulo.t variant_multiply.t
               variant_nomatch.t variant_not.t variant_or.t variant_partial.t
               variant_subtract.t variant_xor.t)

add_custom_target (test ./run_all --verbose
                        DEPENDS ${test_SRCS} task_executable
                        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/test)

add_custom_target (build_tests DEPENDS ${test_SRCS}
                               WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/test)

foreach (src_FILE ${test_SRCS})
  add_executable (${src_FILE} "${src_FILE}.cpp" test.cpp)
  target_link_libraries (${src_FILE} task commands task columns ${TASK_LIBRARIES})
endforeach (src_FILE)

configure_file(run_all run_all COPYONLY)

#SET(CMAKE_BUILD_TYPE gcov)
#SET(CMAKE_CXX_FLAGS_GCOV "--coverage")
#SET(CMAKE_C_FLAGS_GCOV "--coverage")
#SET(CMAKE_EXE_LINKER_FLAGS_GCOV "--coverage")

=== src/columns/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/src/commands
                     ${CMAKE_SOURCE_DIR}/src/columns
                     ${TASK_INCLUDE_DIRS})

set (columns_SRCS Column.cpp Column.h
                  ColDate.cpp ColDate.h
                  ColDepends.cpp ColDepends.h
                  ColDescription.cpp ColDescription.h
                  ColDue.cpp ColDue.h
                  ColEnd.cpp ColEnd.h
                  ColEntry.cpp ColEntry.h
                  ColID.cpp ColID.h
                  ColIMask.cpp ColIMask.h
                  ColMask.cpp ColMask.h
                  ColModified.cpp ColModified.h
                  ColParent.cpp ColParent.h
                  ColProject.cpp ColProject.h
                  ColRecur.cpp ColRecur.h
                  ColScheduled.cpp ColScheduled.h
                  ColStart.cpp ColStart.h
                  ColStatus.cpp ColStatus.h
                  ColString.cpp ColString.h
                  ColTags.cpp ColTags.h
                  ColUntil.cpp ColUntil.h
                  ColUrgency.cpp ColUrgency.h
                  ColUDA.cpp ColUDA.h
                  ColUUID.cpp ColUUID.h
                  ColWait.cpp ColWait.h)

add_library (columns STATIC ${columns_SRCS})

#SET(CMAKE_BUILD_TYPE gcov)
#SET(CMAKE_CXX_FLAGS_GCOV "--coverage")
#SET(CMAKE_C_FLAGS_GCOV "--coverage")
#SET(CMAKE_EXE_LINKER_FLAGS_GCOV "--coverage")

=== src/commands/CMakeLists.txt ===
--- 
+++ 
@@ -51,6 +51,7 @@
                    CmdTimesheet.cpp   CmdTimesheet.h
                    CmdUDAs.cpp        CmdUDAs.h
                    CmdUndo.cpp        CmdUndo.h
+                   CmdUnique.cpp      CmdUnique.h
                    CmdUrgency.cpp     CmdUrgency.h
                    CmdVersion.cpp     CmdVersion.h)

=== debian/changelog ===
task (2.5.0+dfsg-1build1) xenial; urgency=medium

  * No-change rebuild for gnutls transition.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Feb 2016 22:28:03 +0000

task (2.5.0+dfsg-1) unstable; urgency=medium

  * New upstream release: 2.5.0

 -- Sebastien Badia <seb@sebian.fr>  Wed, 21 Oct 2015 23:22:03 +0200

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,6 @@
 Homepage: http://taskwarrior.org
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/task.git
 Vcs-Git: git://anonscm.debian.org/collab-maint/task.git
-XS-Testsuite: autopkgtest
 
 Package: taskwarrior
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export CMAKE_BUILD_TYPE=release

version = $(shell dpkg-parsechangelog -SVersion)

%:
	dh $@

override_dh_auto_clean:
	dh_clean
	rm -f cmake.h commit.h test/basetest/*.pyc test/simpletap/*.pyc
	rm -rf obj-*

override_dh_auto_install:
	# Needed by #710321
	dh_auto_install
	cd debian/tmp/usr/share/doc/task/scripts/bash && mv task.sh task

.PHONY: get-orig-source
get-orig-source:
	sh ./debian/get-orig-source.sh $(version)

# vim:ts=4 sw=4 noet

=== debian/tests/control ===
Tests: taskwarrior
Depends: taskwarrior, perl

Tests: adequate-taskwarrior
Depends: taskwarrior, adequate

Tests: adequate-task
Depends: task, adequate
